﻿using MathNet.Numerics.LinearAlgebra;
using Microsoft.ML.Probabilistic.Math;
using PythonUtils;
using System;
using System.Linq;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            double[] data1 = Range.Create(1.0, 10.0, 1.0).ToArray();
            double[] data2 = Range.Create(1.0, 10.0, 1.0).ToArray();

            NDArray data = NDArray.LoadFrom("click.csv");

            {
                Matrix mat1 = new Matrix(3, 3, data1);
                Matrix mat2 = new Matrix(3, 3, data2);

                Matrix mat3 = mat1 * mat2;

                Console.WriteLine(mat3);
                Console.WriteLine();

                mat3.SetToElementwiseProduct(mat1, mat2);
                Console.WriteLine(mat3);
                Console.WriteLine();
            }

            // Matrix invMat = mat3.Inverse();
            // Console.WriteLine(invMat);
                        
            {
                double[,] matData = data.ToArray2D();
                Matrix mlMatrix = new Matrix(matData);

                Matrix<double> mathMatrix = CreateMatrix.DenseOfArray(mlMatrix.ToArray());
                mlMatrix = new Matrix(mathMatrix.ToArray());
            }

            {
                Matrix<double> mat1 = CreateMatrix.DenseOfColumnMajor(3, 3, data1).Transpose();
                Matrix<double> mat2 = CreateMatrix.DenseOfColumnMajor(3, 3, data2).Transpose();

                var t = mat1 * mat2;
                Console.WriteLine(t);

                Matrix<double> mat3 = mat1.Multiply(mat2);
                Matrix<double> mat4 = mat1.PointwiseMultiply(mat2);
                Matrix<double> invMat = mat4.Inverse();

                Matrix<double> mat5 = CreateMatrix.DenseOfArray(data.ToArray2D());
                Matrix<double> pseudoInvMat = mat5.PseudoInverse();

                Console.WriteLine(mat3);
                Console.WriteLine(mat4);
                Console.WriteLine(invMat);
                Console.WriteLine(pseudoInvMat);
            }
        }
    }
}
