﻿using System;
using System.Collections.Generic;

namespace PythonUtils
{
    public class Range
    { 
        // Is there a constraint that restricts my generic method to numeric types?
        // https://stackoverflow.com/questions/32664/is-there-a-constraint-that-restricts-my-generic-method-to-numeric-types
        public static IEnumerable<T> Create<T>(T start, T stop, T step)
        {
            dynamic dStart = start;
            dynamic dStop = stop;
            dynamic dStep = step;

            if (dStep == 0)
                throw new ArgumentException("Parameter step cannot equal zero.");

            if (dStart < dStop && dStep > 0)
            {
                for (var i = dStart; i < dStop; i += dStep)
                {
                    yield return i;
                }
            }
            else if (dStart > dStop && dStep < 0)
            {
                for (var i = dStart; i > dStop; i += dStep)
                {
                    yield return i;
                }
            }
        }
    }
}
